/// <reference types="node" />
import { Logger } from './logger';
import { NexeOptions } from './options';
import { NexeTarget } from './target';
export interface NexeFile {
    filename: string;
    absPath: string;
    contents: string;
}
export { NexeOptions };
export declare class NexeCompiler {
    options: NexeOptions;
    private start;
    private env;
    private bundle;
    private compileStep;
    log: Logger;
    src: string;
    files: NexeFile[];
    shims: string[];
    startup: string;
    entrypoint: string | undefined;
    bundledInput?: string;
    targets: NexeTarget[];
    target: NexeTarget;
    output: string;
    private nodeSrcBinPath;
    constructor(options: NexeOptions);
    addResource(file: string, content?: Buffer | string): Promise<void>;
    readonly binaryConfiguration: {
        resources: {
            [relativeFilePath: string]: [number, number];
        };
    };
    readonly resourceSize: number;
    readFileAsync(file: string): Promise<NexeFile>;
    writeFileAsync(file: string, contents: string | Buffer): Promise<any>;
    replaceInFileAsync(file: string, replace: string | RegExp, value: string): Promise<void>;
    setFileContentsAsync(file: string, contents: string): Promise<void>;
    quit(): Promise<{}>;
    assertBuild(): void;
    getNodeExecutableLocation(target?: NexeTarget): string;
    private _runBuildCommandAsync;
    private _configureAsync;
    private _buildAsync;
    private _fetchPrebuiltBinaryAsync;
    compileAsync(target: NexeTarget): Promise<NodeJS.ReadableStream>;
    code(): string;
    private _assembleDeliverable;
}
